// Cypress̃Cug킸USB]seXg(Mikitty FirmpEPŒ)
// ړI Cypress̃CuɗȂɂA჌x̓𖾊mɂAnrւ̈ڐAeՂɂB

#include "../StdAfx.h"
#include <InitGuid.h>
#include <SetupApi.h>
#include "DTV_EzUSBFX2_Direct_HvMikitty.h"

DEFINE_GUID( GUID_EZUSBFX2_DRIVER,	0xae18aa60, 0x7f6a, 0x11d4, 0x97, 0xdd, 0x0, 0x1, 0x2, 0x29, 0xb9, 0x59 );

CDTV_EzUSBFX2_Direct_HvMikitty::CDTV_EzUSBFX2_Direct_HvMikitty() : CDTV_Base()
{
	m_hDevice = INVALID_HANDLE_VALUE;
	m_bHvMikittyInit=FALSE;
	m_bOpen = FALSE;
	CDTV_CriticalSection::InitializeCriticalSection(&m_stCS);
}

CDTV_EzUSBFX2_Direct_HvMikitty::~CDTV_EzUSBFX2_Direct_HvMikitty(void)
{
	if(IsInitialized()) Release();
	CDTV_CriticalSection::DeleteCriticalSection(&m_stCS);
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::Initialize(char *szInitString,HWND hWnd,GUID *pGuid)
{
	if(IsInitialized()) return FALSE;
	if(!pGuid) pGuid=(GUID*)&GUID_EZUSBFX2_DRIVER;
	//
	char szDeviceName[MAX_PATH];
	if(!GetDriverPath(pGuid, szDeviceName)) return FALSE;
	m_hDevice = ::CreateFile(szDeviceName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, NULL);
	if(m_hDevice==INVALID_HANDLE_VALUE)
	{
		Release();
		return FALSE;
	}
	return TRUE;
}

void CDTV_EzUSBFX2_Direct_HvMikitty::Release()
{
	DisConnect();
	if(m_hDevice!=INVALID_HANDLE_VALUE) CloseHandle(m_hDevice);
	m_hDevice=INVALID_HANDLE_VALUE;
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::IsInitialized()
{
	return m_hDevice!=INVALID_HANDLE_VALUE?TRUE:FALSE;
}

DWORD CDTV_EzUSBFX2_Direct_HvMikitty::GetExtFunction()
{
	return DTV_EXTFUNC_NONE;
}

DWORD CDTV_EzUSBFX2_Direct_HvMikitty::GetDeviceCount()
{
	if(!IsInitialized()) return 0;
	return 1;
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen)
{
	if(!IsInitialized()) return FALSE;
	lstrcpyn(lpszDevName,"CapUSB",iBufLen);
	return TRUE;
}

DWORD CDTV_EzUSBFX2_Direct_HvMikitty::GetUsbEndpointCount(int iDevNo)
{
	if(!IsInitialized()) return 0;
	return 2;
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo)
{
	if(!IsInitialized()) return FALSE;	
	BOOL bRet=FALSE;

	pUsbEpInfo->DscLen=0x07;
	pUsbEpInfo->DscType=0x05;
	pUsbEpInfo->Address=(iUsbEpNo==0?0x86:0x04);
	pUsbEpInfo->Attributes=0x02;
	pUsbEpInfo->MaxPktSize=0x200;
	pUsbEpInfo->PktsPerFrame=0xbaad;
	pUsbEpInfo->Interval=0x00;
	pUsbEpInfo->TimeOut=0x2710;
	pUsbEpInfo->UsbdStatus=0xbaadf00d;
	pUsbEpInfo->NtStatus=0xbaadf00d;
	return TRUE;
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::IsEndpointEffective(int iDevNo,int iUsbEpAddr)
{
	if(!IsInitialized()) return FALSE;
	return TRUE;
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::Connect(int iDevNo,int iInEpAddr,int iOutEpAddr)
{
	if(!IsInitialized()) return FALSE;
	if(IsConnect()) return FALSE;

	struct DTV_ThreadParam *pReq=NULL;
	struct DTV_ThreadParam *pRes=NULL;
	try
	{
		pReq=new struct DTV_ThreadParam;
		pRes=new struct DTV_ThreadParam;
		if(!pReq||!pRes) throw 101;
		ZeroMemory(pReq,sizeof(struct DTV_ThreadParam));
		ZeroMemory(pRes,sizeof(struct DTV_ThreadParam));
		pReq->pClassPtr=pRes->pClassPtr=this;
		m_stThread.hExitEvent=pReq->hExitEvent=pRes->hExitEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
		if(!m_stThread.hExitEvent) throw 102;

		struct DTV_EzUSBFX2_ReqParam *pReqParam=new struct DTV_EzUSBFX2_ReqParam;
		if(!pReqParam) throw 103;
		ZeroMemory(pReqParam,sizeof(struct DTV_EzUSBFX2_ReqParam));
		pReq->pData=pReqParam;

		// Gh|Cg
		int iInPos,iOutPos;
		int nEP=GetUsbEndpointCount(iDevNo);
		iInPos=iOutPos=-1;
		for(int i=0;i<nEP;i++)
		{
			struct DTV_UsbEndpointInfo stUsbEP;
			if(GetUsbEndpointInfo(iDevNo,i,&stUsbEP))
			{
				if(iInEpAddr==stUsbEP.Address) iInPos=i;
				if(iOutEpAddr==stUsbEP.Address) iOutPos=i;
			}
		}
		// foCXJăGh|Cg擾
		m_bOpen = TRUE;
		if(iInPos!=-1) pReqParam->byEP_In=(BYTE)iInEpAddr;
		if(iOutPos!=-1) pReqParam->byEP_Out=(BYTE)iOutEpAddr;

		// 񓯊L[̍쐬
		if(!MakeXferQueue())
		{
			throw 401;
		}

		// ]󋵂̃Zbg
		ClearTransferInfo();
		
		m_stThread.stRequest.hThread=CreateThread(NULL,0,XferRequestThreadEntry,pReq,CREATE_SUSPENDED,&m_stThread.stRequest.dwThreadID);
		m_stThread.stResponce.hThread=CreateThread(NULL,0,XferResponceThreadEntry,pRes,CREATE_SUSPENDED,&m_stThread.stResponce.dwThreadID);
		if(!m_stThread.stRequest.hThread||!m_stThread.stResponce.hThread)
		{
			throw 501;
		}

		// Jn
		ResumeThread(m_stThread.stRequest.hThread);
		ResumeThread(m_stThread.stResponce.hThread);
	}
	catch(int err_code)
	{
		DTV_CATCH_INT_ERROR_CODE(err_code);
		if(m_stThread.stRequest.hThread)
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
		if(m_stThread.stResponce.hThread)
			TerminateThread(m_stThread.stResponce.hThread,0xffffffff);
		if(m_stThread.hExitEvent)
		{
			CloseHandle(m_stThread.hExitEvent);
		}
		ZeroMemory(&m_stThread,sizeof(struct DTV_CurrentThread));

		FreeXferQueue();
		if(pReq)
		{
			if(pReq->pData) delete pReq->pData;
			delete pReq;
		}
		if(pRes)
		{
			if(pRes->pData) delete pRes->pData;
			delete pRes;
		}
		if(IsConnect())
		{
			m_bOpen = FALSE;
		}
		return FALSE;
	}
	return TRUE;
}

void CDTV_EzUSBFX2_Direct_HvMikitty::DisConnect()
{
	if(IsConnect())
	{
		SetEvent(m_stThread.hExitEvent);
		HANDLE hWait[2]={m_stThread.stRequest.hThread,m_stThread.stResponce.hThread};
		if(WaitForMultipleObjects(2,hWait,TRUE,10*1000)!=WAIT_OBJECT_0)
		{
			// ^CAEgȂ̂ŋ~
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
			TerminateThread(m_stThread.stResponce.hThread,0xffffffff);
		}
		DWORD dwExitCode;
		GetExitCodeThread(m_stThread.stRequest.hThread,&dwExitCode);
		GetExitCodeThread(m_stThread.stResponce.hThread,&dwExitCode);

		// foCX
		m_bOpen = FALSE;

		// L[J
		FreeXferQueue();

		// nh
		CloseHandle(m_stThread.stRequest.hThread);
		CloseHandle(m_stThread.stResponce.hThread);
		CloseHandle(m_stThread.hExitEvent);
		ZeroMemory(&m_stThread,sizeof(struct DTV_CurrentThread));
	}
}

BOOL CDTV_EzUSBFX2_Direct_HvMikitty::IsConnect()
{
	if(!IsInitialized()) return FALSE;
	return m_bOpen;
}

DWORD CDTV_EzUSBFX2_Direct_HvMikitty::XferRequestProc(struct DTV_ThreadParam *lpParameter)
{
	struct DTV_EzUSBFX2_ReqParam *pReqParam=(struct DTV_EzUSBFX2_ReqParam*)lpParameter->pData;

	BYTE SendData[256];
	BYTE RecvData[256];
	DWORD dwBufLen,dwRxdBufLen;
	CyUSB_IoHeader *pHead = (CyUSB_IoHeader*)SendData;

	// Hv-Mikitty t@[p
	if(m_bHvMikittyInit&&pReqParam->byEP_Out)
	{
		dwBufLen=sizeof(CyUSB_IoHeader);
		ZeroMemory(pHead,dwBufLen);
		pHead->ucEndpointAddress=pReqParam->byEP_Out;
		dwRxdBufLen=2;
		RecvData[0]=0x80;
		RecvData[1]=0x00;
		XferData(m_hDevice,IOCTL_ADAPT_SEND_NON_EP0_DIRECT,SendData,dwBufLen,RecvData,dwRxdBufLen,false);
		dwRxdBufLen=1;
		RecvData[0]=0x8B;
		XferData(m_hDevice,IOCTL_ADAPT_SEND_NON_EP0_DIRECT,SendData,dwBufLen,RecvData,dwRxdBufLen,false);
		RecvData[0]=0x80;
		RecvData[1]=0x01;
		XferData(m_hDevice,IOCTL_ADAPT_SEND_NON_EP0_DIRECT,SendData,dwBufLen,RecvData,dwRxdBufLen,false);
		Sleep(100);
	}

	// ]f[^TCY
	CyUSB_SetTransferInfo stTransferSize;
	stTransferSize.ucEndpointAddress=pReqParam->byEP_In;
	stTransferSize.dwTransferSize=DTV_EzUSBFX2_ASYNC_XFER_SIZE;
	if(!XferData(m_hDevice,IOCTL_ADAPT_SET_TRANSFER_SIZE,(BYTE*)&stTransferSize,sizeof(CyUSB_SetTransferInfo),(BYTE*)&stTransferSize,sizeof(CyUSB_SetTransferInfo),false))
	{
		// ݒ莸s
	}

	// ]NGXg쐬
	dwBufLen=sizeof(CyUSB_IoHeader);
	ZeroMemory(pHead,dwBufLen);
	pHead->ucEndpointAddress=pReqParam->byEP_In;

	// NGXg[v
	while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0)
	{
		struct DTV_EzUSBFX2_Request *pItem=NULL;			
		if(m_ReqWait.size()>0)
		{
			// Wait쏜
			{
				CDTV_CriticalSection sec(&m_stCS);
				pItem=m_ReqWait.front();
				m_ReqWait.pop_front();
			}
			ZeroMemory(&pItem->Overlap,sizeof(OVERLAPPED));
			pItem->Request=*pHead;
			pItem->Overlap.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);
			pItem->byEndPoint=pHead->ucEndpointAddress;
			pItem->buf_len=DTV_EzUSBFX2_ASYNC_XFER_SIZE;
			pItem->recv_size=0;
#ifdef _DEBUG
			ZeroMemory(pItem->buf,pItem->buf_len);
#endif
			BeginDataXfer(m_hDevice,IOCTL_ADAPT_SEND_NON_EP0_DIRECT,(BYTE*)&pItem->Request,dwBufLen,pItem->buf,pItem->buf_len,&pItem->recv_size,&pItem->Overlap);
			// Busyɒǉ
			{
				CDTV_CriticalSection sec(&m_stCS);
				m_ReqBusy.push_back(pItem);
			}
		}		
		Sleep(1);
	}

	// I
	if(pReqParam)
	{
		BYTE byEP;
		byEP=pReqParam->byEP_In;
		XferData(m_hDevice,IOCTL_ADAPT_ABORT_PIPE,&byEP,1,NULL,0,false);
		byEP=pReqParam->byEP_Out;
		XferData(m_hDevice,IOCTL_ADAPT_ABORT_PIPE,&byEP,1,NULL,0,false);
		delete pReqParam;
	}
	delete lpParameter;
	ExitThread(1);
	return 0;
}

DWORD CDTV_EzUSBFX2_Direct_HvMikitty::XferResponceProc(struct DTV_ThreadParam *lpParameter)
{

    // M[v
	while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0 || m_ReqBusy.size()>0)
	{
		struct DTV_EzUSBFX2_Request *pItem=NULL;
		bool bRet;			
		if(m_ReqBusy.size()>0)
		{
			// Busy̐擪擾
			{
				CDTV_CriticalSection sec(&m_stCS);
				pItem=m_ReqBusy.front();
				m_ReqBusy.pop_front();
			}

			DWORD dwWaitRet = WaitForSingleObject(pItem->Overlap.hEvent,1000);
			bRet= dwWaitRet==WAIT_OBJECT_0 ? true : false;
			if(bRet)
			{
				bRet=GetOverlappedResult(m_hDevice,&pItem->Overlap,(DWORD*)&pItem->recv_size,FALSE)?true:false;
				if(bRet)
				{
					if(pItem->buf_len>0)
					{
						m_stTransferInfo.ui64RecvTotal+=pItem->recv_size;
						DoDTVDataCallback(pItem->buf,pItem->recv_size,m_stTransferInfo.ui64RecvTotal);						
					}
					m_stTransferInfo.dwSuccess++;
				} else {
					m_stTransferInfo.dwFail++;
				}
			} else {
				DWORD dwErr = GetLastError();
				m_stTransferInfo.dwFail++;
			}
			CloseHandle(pItem->Overlap.hEvent);
			pItem->Overlap.hEvent=NULL;
			// Waitɒǉ
			{
				CDTV_CriticalSection sec(&m_stCS);
				m_ReqWait.push_back(pItem);
			}
		}			

		Sleep(1);
	}

	// I
	delete lpParameter;
	ExitThread(1);
	return 0;
}

// 񓯊L[쐬
BOOL CDTV_EzUSBFX2_Direct_HvMikitty::MakeXferQueue()
{
	for(int i=0;i<DTV_EzUSBFX2_ASYNC_XFER_REQ_NUM;i++)
	{
		struct DTV_EzUSBFX2_Request *pItem=new struct DTV_EzUSBFX2_Request;
		if(!pItem)
		{
			FreeXferQueue();
			return FALSE;
		}
		ZeroMemory(pItem,sizeof(struct DTV_EzUSBFX2_Request));
		m_ReqWait.push_back(pItem);
	}
	return TRUE;
}

// 񓯊L[j
void CDTV_EzUSBFX2_Direct_HvMikitty::FreeXferQueue()
{
	struct DTV_EzUSBFX2_Request *pItem;
	// ҋ@
	int iWait=0,iBusy=0;
	while(m_ReqWait.begin()!=m_ReqWait.end())
	{
		pItem=m_ReqWait.front();
		delete pItem;
		m_ReqWait.pop_front();
		iWait++;
	}
	// NGXg
	while(m_ReqBusy.begin()!=m_ReqBusy.end())
	{
		pItem=m_ReqBusy.front();
		bool bRet=WaitForSingleObject(&pItem->Overlap.hEvent,1000)==WAIT_OBJECT_0?true:false;
		if(pItem->Overlap.hEvent) CloseHandle(pItem->Overlap.hEvent);
		delete pItem;
		m_ReqBusy.pop_front();
		iBusy++;
	}
}

// GUIDhCõpX擾(CreateFileŊJpX)
BOOL CDTV_EzUSBFX2_Direct_HvMikitty::GetDriverPath(GUID *pGuid, LPSTR lpszPath)
{
	HDEVINFO hDevInfo = SetupDiGetClassDevs(pGuid,0,NULL,DIGCF_PRESENT|DIGCF_INTERFACEDEVICE);
	if(hDevInfo == INVALID_HANDLE_VALUE)return FALSE;

	SP_DEVICE_INTERFACE_DATA DeviceInterfaceData;
	DeviceInterfaceData.cbSize = sizeof(DeviceInterfaceData);
	if(!SetupDiEnumDeviceInterfaces( hDevInfo,NULL,pGuid,0,&DeviceInterfaceData))
	{
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
	}

	DWORD dwBuffLen = 0;
	SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &dwBuffLen, NULL);

	dwBuffLen += sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA) + 1;
	SP_DEVICE_INTERFACE_DETAIL_DATA *pDeviceInterfaceDetailData = (SP_DEVICE_INTERFACE_DETAIL_DATA *)_alloca(dwBuffLen);
	pDeviceInterfaceDetailData->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);

	if(!SetupDiGetDeviceInterfaceDetail(hDevInfo, &DeviceInterfaceData, pDeviceInterfaceDetailData, dwBuffLen, NULL, NULL))
	{
		SetupDiDestroyDeviceInfoList(hDevInfo);
		return FALSE;
	}
	SetupDiDestroyDeviceInfoList(hDevInfo);
	lstrcpy(lpszPath, pDeviceInterfaceDetailData->DevicePath);
	return TRUE;
}

// Pƃf[^]s(^񓯊)
int CDTV_EzUSBFX2_Direct_HvMikitty::XferData(HANDLE hDevice,DWORD dwIoCode, BYTE *pSendData, DWORD dwSendSize, BYTE *pRecvBuf, DWORD dwRecvBufLen,BOOL bOverlap)
{
	if(hDevice==INVALID_HANDLE_VALUE) return -1;

	OVERLAPPED OverLapped;
	ZeroMemory(&OverLapped, sizeof(OverLapped));
	OverLapped.hEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
	if(!OverLapped.hEvent) return -1;

	BYTE *pSendTmp = new BYTE[dwSendSize];
	memcpy(pSendTmp,pSendData,dwSendSize);
	DWORD dwReturned = 0;
	if(!DeviceIoControl(hDevice,dwIoCode,pSendTmp,dwSendSize,pRecvBuf,dwRecvBufLen,&dwReturned,bOverlap?&OverLapped:NULL))
	{
		DWORD dwErr=GetLastError();
		if(dwErr!=ERROR_IO_PENDING)
		{
			CloseHandle(OverLapped.hEvent);
			delete []pSendTmp;
			return -1;
		}
		if(WaitForSingleObject(hDevice,1000)!=WAIT_OBJECT_0)
		{
			::CloseHandle(OverLapped.hEvent);
			delete []pSendTmp;
			return -1;
		}
		if(!GetOverlappedResult(hDevice,&OverLapped,&dwReturned,TRUE))
		{
			CloseHandle(OverLapped.hEvent);
			delete []pSendTmp;
			return -1;
		}
	}
	CloseHandle(OverLapped.hEvent);
	delete []pSendTmp;
	return (int)dwReturned;
}

// 񓯊]Jn
BOOL CDTV_EzUSBFX2_Direct_HvMikitty::BeginDataXfer(HANDLE hDevice, DWORD dwIoCode, BYTE *pSendData, DWORD dwSendSize, BYTE *pRecvBuf,DWORD dwRecvBufLen,DWORD *pRecvSize,OVERLAPPED *pOvelap)
{
	if(hDevice==INVALID_HANDLE_VALUE) return FALSE;
	if(!DeviceIoControl(hDevice,dwIoCode,pSendData,dwSendSize,pRecvBuf,dwRecvBufLen,pRecvSize,pOvelap))
	{
		DWORD dwErr=GetLastError();
		if(dwErr!=ERROR_IO_PENDING)
		{
			return FALSE;
		}	
	}
	return TRUE;
}
